var SFILE = SFILE || {};
if (typeof require !== 'undefined' && !global.fs) {
    SFILE.fs = require('fs').promises;
}else{
    SFILE.fs = fs;
}

SFILE.STUB_COUNT = 0;
SFILE.STUB_CURRENT_FILES = [];

SFILE.getAvailableFilesForGPT = async function(selectedProjects, stubsData){
      console.log("selectedProjects");
      console.log(selectedProjects);
      let retText = "";
      let newLine = "\n";
      
      let justFiles = new Array();
      let justFilesLinux = new Array();
      let justFilesText = "";
      let projectNameArr = new Array();
      let fileData = new Array();
      
      if(!stubsData){
          stubsData = STUBS.stubsData;
      }
      
      
      for(let projectName in stubsData){
          
          if(!selectedProjects.includes(projectName)){
              console.log("project not selected, so files not available to chatgpt " + projectName);
              continue;
          }         
          let allFiles = stubsData[projectName];
          for(let a = 0; a < allFiles.length; a++){
              let aFile = allFiles[a];
              let filepath = aFile['file_path'];
              //let lineNums = aFile['line_count'];   
              let isIncluded = aFile['is_included'];
              
              if(isIncluded){
                // Ensure the filepath starts with a slash on macOS (Darwin)
                if (STUBS.platform === 'darwin' && !filepath.startsWith('/')) {
                    filepath = '/' + filepath;
                }                     
                justFiles.push(filepath);
                fileData.push(aFile);
                projectNameArr.push(projectName);
              }
          }              
      }
      
      //console.log("all selected files");
      //console.log(justFiles);
      let filesTextLinux = "";
      for(let f = 0; f < justFiles.length; f++){
          let sFile = justFiles[f];          
          justFilesText += sFile + newLine;
          justFilesLinux.push(sFile.replace(/\\/g, '/'));
          filesTextLinux += sFile.replace(/\\/g, '/') + newLine;
      }
      justFilesText = justFilesText.trim();
      //console.log("list of files");
      //console.log(justFilesText);
            
      return {files: justFiles, files_linux: justFilesLinux, files_text: justFilesText, files_text_linux: filesTextLinux, justfiles_data: fileData, just_project_names: projectNameArr};      
};

/*
SFILE.getStubFilesCombined = async function(stubPaths, shortPaths){
    let combinedData = '';

    for (let f = 0; f < stubPaths.length; f++) {
        let filePath = stubPaths[f];
        let shortPath = shortPaths[f];
        try {
            const data = await SFILE.fs.readFile(filePath, 'utf8');
            combinedData += "=============\n";
            combinedData += `FILE: ${shortPath}\n${data}\n`;
        } catch (err) {
            console.error(`Error reading file ${filePath}: ${err.message}`);
            // Optionally, you can continue to the next file or throw an error
        }
    }

    return combinedData;

};
*/

SFILE.getStubFilesCombined = async function(projectName, shortPaths, fullPaths){
    let combinedData = '';
    
    console.log("getting short paths for project " + projectName);
    console.log(shortPaths);

    try {
        const stubFiles = await dexieDB.getStubFilesFromDexie(projectName);
        console.log("stubFiles getStubFiles dexie data");
        console.log(stubFiles);
        for (let f = 0; f < shortPaths.length; f++) {
            let shortPath = shortPaths[f];
            let fullPath = fullPaths[f];
            let stubFilePaths = stubFiles.map(file => file.file_path);
            console.log("just filepaths data");
            console.log(stubFilePaths);
            
            if (arrayHasPath(stubFilePaths, shortPath)) {
                console.log("has path");
                let matchingPath = arrayGetPath(stubFilePaths, shortPath);
                let stubFile = stubFiles.find(file => file.file_path === matchingPath);
                if (stubFile) {
                    combinedData += "=============\n";
                    combinedData += `FILE: ${shortPath}\n${stubFile.stub_file}\n`;
                } else {
                    console.error(`Stub file not found for path2 ${shortPath}`);
                }
            } else {    
                console.error(`Stub file not found for path1 ${shortPath}`);
                console.log("Workaround - reading file to generate stub : " + fullPath);
                try {
                  const { stubResult, md5, index, type } = await getFileStubPromise(fullPath, '', f);
                  if (stubResult) {
                    combinedData += "=============\n";
                    combinedData += `FILE: ${shortPath}\n${stubResult}\n`;

                    // Update STUBS.stubsData if needed
                    if (STUBS.stubsData[projectName] && STUBS.stubsData[projectName][index]) {
                      STUBS.stubsData[projectName][index].stub_file = stubResult;
                      STUBS.stubsData[projectName][index].md5 = md5;
                      console.log(`stub updated (${type}): `);
                      console.log(stubResult);
                      console.log(STUBS.stubsData[projectName][index]);
                    }
                  } else {
                    console.error(`Failed to generate stub for ${shortPath}`);
                  }
                } catch (error) {
                  console.error(`Error generating stub for ${shortPath}:`, error);
                  if(fs.existsSync(fullPath)){
                    const fullFile = readFileWithCache(fullPath);
                    console.log("Workaround workaround - getting full file");
                    combinedData += `FILE: ${shortPath}\n${fullFile}\n`;
                  }else{
                      console.log("File does not exist, should be removed from stubs " + shortPath);
                  }
                }
            }
        }
    } catch (err) {
        console.error(`Error getting stub files: ${err.message}`);
    }

    return combinedData;
};

SFILE.getStubFileContent = async function(projectName, filePath) {
  try {
    console.log(`Getting stub file content for project ${projectName} and file ${filePath}`);
    const stubFile = await dexieDB.getStubFileByPath(projectName, filePath);
    
    if (stubFile && stubFile.stub_file) {
      return `=============\nSTUB FILE: ${filePath}\n${stubFile.stub_file}\n`;
    } else {
        //Should get promise to get content? 
        //const { stubResult, md5, index, type } = await getFileStubPromise(fullPath, '', f);
      console.error(`Stub file content not found for ${filePath}`);
      return null;
    }
  } catch (err) {
    console.error(`Error getting stub file content: ${err.message}`);
    return null;
  }
};

SFILE.getFileData = async function(allPaths){
    let retArray = [];

    for (let f = 0; f < allPaths.length; f++) {
        let filePath = allPaths[f];
        try {
            const data = readFileWithCache(filePath);
            retArray.push(data);
        } catch (err) {
            console.error(`Error reading file ${filePath}: ${err.message}`);
            // Optionally, you can continue to the next file or throw an error
        }
    }

    return retArray;
};

SFILE.getTributeProjectFiles = function(selectedProjects) {
    let projectFiles = [];
    for (let projectName of selectedProjects) {
        if (STUBS.stubsData.hasOwnProperty(projectName)){
            for (let file of STUBS.stubsData[projectName]) {
                if (file['is_included']) {
                    projectFiles.push({key: file['file_path'], value: file['file_path']});
                }
            }
        }
    }
    return projectFiles;
};

SFILE.loadCheckedProjects = function(checkedProjects) {
  const checkboxesExist = () => document.querySelectorAll('.project-checkbox input[type="checkbox"]').length > 0;

  const loadProjects = () => {
    const checkboxes = document.querySelectorAll('.project-checkbox input[type="checkbox"]');
    let hasCheckbox = false;
    checkboxes.forEach(checkbox => {
      const projectSlug = checkbox.dataset.projectSlug;
      if (checkedProjects.includes(projectSlug)) {
        checkbox.checked = true;
        hasCheckbox = true;
        //console.log("checking");
      } else {
        checkbox.checked = false;
        //console.log("not checking");
      }
    });
    if(!hasCheckbox){
        if (checkboxes.length > 0) {
          checkboxes[0].checked = true;
        }
    }
  };

  if (checkboxesExist()) {
    loadProjects();
  } else {
    const intervalId = setInterval(() => {
      if (checkboxesExist()) {
        clearInterval(intervalId);
        loadProjects();
      }
    }, 500);
  }
};

// Function to create checkboxes for each project in the UI
SFILE.createProjectCheckboxes = function(projects) {
  const directoryTree = document.getElementById('directory-tree');
  directoryTree.innerHTML = ''; // Clear existing content

  let firstProject = true; // Flag to track the first project

  projects.forEach(project => {
    //let checked = firstProject ? 'checked' : ''; // If it's the first project, add 'checked' attribute
    let projectSlug = project.project_slug;
    let projectHtml = `<div id="project-container-${project.project_slug}" class="project-checkbox-container">
        <div class="project-checkbox">
            <input type="checkbox" class="project-checkbox" id="project-checkbox-${project.project_slug}" data-project-slug="${project.project_slug}" data-project-path="${project.folder}">
            <label for="project-checkbox-${project.project_slug}">${project.name}</label>
            <a href="#" class="edit-project tooltip-button" data-tooltip="Edit ${project.name}"   data-project-slug="${project.project_slug}">
                <i class="ti ti-edit"></i>
            </a>
        </div>
        <div id="project-syncing-${project.project_slug}" class="project-syncing">
            <div class="progress-bar-container-${project.project_slug}">
                <div id="stubprogress_${project.project_slug}" class="project-name">syncing</div>
                <div class="progress-bar progress-bar-${project.project_slug}" style="width: 0%"></div>
            </div>        
        </div>
        <div class="project-context-container project-context-container-${project.project_slug}">
            <div id="contextfiles_${project.project_slug}" class="project-context-files-container">
            </div>
        </div>
    </div>`;
    
    $(directoryTree).append(projectHtml);
    tooltip_tool();

    if (firstProject) {
      firstProject = false; // Reset the flag after the first project
    }
  });
};

SFILE.getProjectDataByName = function(projectName) {
  const projectData = [];
  const projectPaths = [];
  const projectDescriptions = [];
  const projectRules = [];

  const checkboxes = document.querySelectorAll('.project-checkbox input[type="checkbox"]');
  checkboxes.forEach(checkbox => {
    const theSlug = checkbox.dataset.projectSlug;
    if (theSlug === projectName) {
      let projectPath = checkbox.dataset.projectPath;

      // Ensure the project path starts with a slash on macOS (Darwin)
      if (STUBS.platform === 'darwin' && !projectPath.startsWith('/')) {
        projectPath = '/' + projectPath;
        console.log("new project path " + projectPath);
      }

      projectData.push(theSlug);
      projectPaths.push(projectPath);
      let myproject = STUBS.ALL_PROJECT_ARR.find(p => p.project_slug === theSlug);
      if (myproject) {
        projectDescriptions.push(myproject.description);
        projectRules.push(myproject.llm_rules);
      } else {
        projectDescriptions.push("");
        projectRules.push("");
      }
    }
  });

  console.log("Project data for " + projectName + " returning");
  console.log(projectData);
  console.log(projectPaths);
  console.log(projectDescriptions);

  return { projectData, projectPaths, projectDescriptions, projectRules };
};
// Function to get the list of checked projects
SFILE.getCheckedProjects = function() {
  const checkedProjects = [];
  const checkedProjectPaths = [];
  const checkedProjectDescriptions = [];
  const checkedProjectRules = [];
  const checkboxes = document.querySelectorAll('.project-checkbox input[type="checkbox"]');
  checkboxes.forEach(checkbox => {
    if (checkbox.checked) {
      let theSlug = checkbox.dataset.projectSlug;
      let projectPath = checkbox.dataset.projectPath;

      // Ensure the project path starts with a slash on macOS (Darwin)
      if (STUBS.platform === 'darwin' && !projectPath.startsWith('/')) {
        projectPath = '/' + projectPath;
        console.log("new project path " + projectPath);
      }

      checkedProjects.push(theSlug);
      checkedProjectPaths.push(projectPath);
      let myproject = STUBS.ALL_PROJECT_ARR.find(p => p.project_slug === theSlug);
      if (myproject) {
          checkedProjectDescriptions.push(myproject.description);
          checkedProjectRules.push(myproject.llm_rules);
      } else {
          checkedProjectDescriptions.push("");
          checkedProjectRules.push("");
      } 

    }
  });
  console.log("checkedProjects returning");
  console.log(checkedProjects);
  console.log(checkedProjectPaths);
  console.log(checkedProjectDescriptions);

  
  return {checkedProjects, checkedProjectPaths, checkedProjectDescriptions, checkedProjectRules};
};

SFILE.getAllProjects = function() {
  const allProjects = [];
  const allProjectPaths = [];
  const checkboxes = document.querySelectorAll('.project-checkbox input[type="checkbox"]');
  checkboxes.forEach(checkbox => {
      allProjects.push(checkbox.dataset.projectSlug);
      allProjectPaths.push(checkbox.dataset.projectPath);
  });
  return {allProjects, allProjectPaths};
};

// Example usage
// SFILE.createProjectCheckboxes({Project1: 'path1', Project2: 'path2'});
// const selectedProjects = SFILE.getCheckedProjects();



/***************** FOR THE ADD / EDIT PROJECT MODAL ******************************/
function createProjectRoots(parentElement, projectName, projectPath) {
  SFILE.STUB_COUNT = 0;
  SFILE.STUB_CURRENT_FILES = [];
  parentElement.innerHTML = ''; // Clear existing content
  const list = document.createElement('ul');
  parentElement.appendChild(list);
  const listItem = document.createElement('li');
  listItem.textContent = projectName;
  listItem.classList.add('tree-item', 'directory', 'project-root');
  listItem.dataset.projectName = projectName;
  listItem.dataset.fullPath = projectPath;
  list.appendChild(listItem);    
  createDirectoryTree(projectName, listItem, projectPath, true);
}
/*
async function checkAndExpandProjectRoot(projectRoot) {
  const projectName = projectRoot.dataset.projectName;
  const fullPath = projectRoot.dataset.fullPath;
  // Get the project data
  const projectData = STUBS.filesData[projectName] || [];
  // Checking if there's any checked file in the project
  const hasCheckedFile = projectData.some(fileData => fileData.selection_state === 2);
  if (hasCheckedFile) {
    createDirectoryTree(projectName, projectRoot, fullPath, true);
  }
}
*/
function toggleDirectory(directoryItem) {
    //console.log("toggling");
    console.log(directoryItem);
  const childList = directoryItem.querySelector('ul');
  if (childList) {
      //console.log("has childlist");
      childList.classList.toggle('collapsed');
      directoryItem.classList.toggle('expanded');
  } else {
    // If the directory is not expanded, expand it
      //console.log("no childlist");
    
    const projectName = directoryItem.dataset.projectName;
    const fullPath = directoryItem.dataset.fullPath;
    createDirectoryTree(projectName, directoryItem, fullPath);
  }
}
function getFileData(projectName, filePath) {
  let projectData = STUBS.filesData[projectName] || [];
  let fileData = projectData.find(file => file.path === filePath);
  if (!fileData) {
    fileData = {
      selection_state: 0,
      path: filePath,
      name: path.basename(filePath)
    };
    projectData.push(fileData);
    STUBS.filesData[projectName] = projectData;
  }
  return fileData;
}


function createDirectoryTree(projectName, parentElement, folderPath, shouldExpand = true) {
    let checkboxIndex = 1;
    let directoryHasCheckedFile = false;
    fs.readdir(folderPath, (err, files) => {
        if (err) {
            console.error(err);
            return;
        }
        $(parentElement).children('ul').remove();
        const list = document.createElement('ul');
        parentElement.appendChild(list);
        const filesInDir = [];
        const directoriesInDir = [];

        let stubignoreFile = path.join(folderPath, '.stubignore');
        let gitignoreFile = path.join(folderPath, '.gitignore');
        let defaultStubIgnore = path.join(STUBS.appPath, '.defaultstubignore');
        let myStubIgnore = null;
        let myGitIgnore = null;
        if($('#default-stub-ignore').length > 0 && $('#default-stub-ignore').val()){
            console.log("using .stubignore from textarea");
            //if modal is open this should be available
            let currentStubFile = $('#default-stub-ignore').val();
            myStubIgnore = gitignoreParser.compile(currentStubFile);
        }
        else if (fs.existsSync(stubignoreFile)) {
            let contentOfStubIgnore = readFileWithCache(stubignoreFile);
            myStubIgnore = gitignoreParser.compile(contentOfStubIgnore);
        } else {
            let contentOfDefaultStubIgnore = readFileWithCache(defaultStubIgnore);
            myStubIgnore = gitignoreParser.compile(contentOfDefaultStubIgnore);
        }
        
        if (fs.existsSync(gitignoreFile)) {
            let contentOfGitIgnore = readFileWithCache(gitignoreFile);
            myGitIgnore = gitignoreParser.compile(contentOfGitIgnore);
        }

       files.forEach(file => {
            const fullPath = path.join(folderPath, file);
            fs.stat(fullPath, (err, stats) => {
                if (err) {
                    console.error(err);
                    return;
                }
                const itemData = {
                    file,
                    fullPath,
                    stats
                };
                if (stats.isDirectory()) {
                    directoriesInDir.push(itemData);
                } else {
                    filesInDir.push(itemData);
                }
                if (directoriesInDir.length + filesInDir.length === files.length) {
                    // Sort directoriesInDir alphabetically by file name
                    directoriesInDir.sort((a, b) => a.file.localeCompare(b.file));

                    directoriesInDir.forEach(itemData => {
                        processDirectoryItem(itemData, projectName, parentElement, list, checkboxIndex, directoryHasCheckedFile, shouldExpand, myStubIgnore, myGitIgnore);
                        checkboxIndex++;
                    });
                    filesInDir.forEach(itemData => {
                        processDirectoryItem(itemData, projectName, parentElement, list, checkboxIndex, directoryHasCheckedFile, shouldExpand, myStubIgnore, myGitIgnore);
                        checkboxIndex++;
                    });
                }
            });
        });
    });
}

function processDirectoryItem(itemData, projectName, parentElement, list, checkboxIndex, directoryHasCheckedFile, shouldExpand, myStubIgnore, myGitIgnore) {
    const { file, fullPath, stats } = itemData;
    const listItem = document.createElement('li');
    list.appendChild(listItem);
    listItem.classList.add('tree-item-container');
    listItem.dataset.projectName = projectName;
    listItem.dataset.fullPath = fullPath;
    const itemName = document.createElement('span');
    itemName.textContent = file;
    itemName.classList.add('tree-item');
    itemName.dataset.projectName = projectName;
    itemName.dataset.fullPath = fullPath;
    const projectFolderPath = parentElement.closest('.project-root').dataset.fullPath;
    let relativeFilePath = path.relative(projectFolderPath, fullPath);
    relativeFilePath = path.normalize(relativeFilePath).replace(/\\/g, '/');    
    //console.log("==================");
    //console.log("testing " + relativeFilePath);
    

    
    if (myStubIgnore != null && myStubIgnore.inspects(relativeFilePath)) {
        //console.log(".stubignore linethrough");
        //console.log(relativeFilePath);
        itemName.style.textDecoration = 'line-through';
    }
    if (myGitIgnore != null && myGitIgnore.inspects(relativeFilePath)) {
        //console.log(".gitignore linethrough");
        //console.log(relativeFilePath);        
        itemName.style.textDecoration = 'line-through';
    }    
  // Check if the current item is a file
  const isFile = !stats.isDirectory();
  if (!stats.isDirectory()) {
    // Call getFileData() for all files when building the directory tree
    const fileData = getFileData(projectName, fullPath);
    // Add 3-state checkbox
    /*
    const checkbox = document.createElement('input');
    checkbox.type = 'checkbox';
    checkbox.classList.add('file-checkbox');
    checkbox.id = "check" + checkboxIndex;
    listItem.appendChild(checkbox);
    listItem.classList.add('file-icon');
    listItem.classList.add('file-icon');         
    const checkboxOverlay = document.createElement('div');
    checkboxOverlay.classList.add('checkbox-overlay');
    listItem.appendChild(checkboxOverlay);
    directoryHasCheckedFile = false;
         
     */
    if(!itemName.style.textDecoration.includes('line-through')) {
        SFILE.STUB_COUNT++;
        SFILE.STUB_CURRENT_FILES.push(relativeFilePath);        
    }        
    
    // Update the checkbox state based on the saved file data
    if (fileData.selection_state === 1) {
      checkbox.indeterminate = true;
      //checkbox.indeterminate = true;
    } else if (fileData.selection_state === 2) {
      directoryHasCheckedFile = true;
      checkbox.checked = true;
      //checkbox.checked = true;
    }
  } else {
    listItem.classList.add('directory');
    listItem.classList.add('folder-icon');
    itemName.addEventListener('click', (event) => {
      event.preventDefault();
      event.stopPropagation();
      toggleDirectory(listItem);
    });
    
    // Expand the directory if it's not ignored
    if (shouldExpand && !itemName.style.textDecoration.includes('line-through')) {
        toggleDirectory(listItem);
    }    
  }
  listItem.appendChild(itemName);
  const hiddenLink = document.createElement('a');
  hiddenLink.href = fullPath;
  hiddenLink.style.display = 'none';
  listItem.appendChild(hiddenLink);
  // If the directory contains a checked file, expand it
  if (shouldExpand && directoryHasCheckedFile) {
    toggleDirectory(parentElement);
  }
}




if (!process.type) {
    module.exports = SFILE;
}

