const { contextBridge, ipcRenderer } = require('electron');

contextBridge.exposeInMainWorld('electronAPI', {
  // Methods to communicate with the main process
  getOpenAIAPIKey: () => ipcRenderer.invoke('get-openai-api-key'),
  sendDebugData: (data) => ipcRenderer.send('realtime-debug', data),
  sendAudioData: (data) => ipcRenderer.send('realtime-send-audio', data),
  createResponse: () => ipcRenderer.send('realtime-create-response'),
  onConversationUpdated: (callback) => ipcRenderer.on('realtime-conversation-updated', callback),
  onError: (callback) => ipcRenderer.on('realtime-error', callback),
  sendCancelEvent: () => ipcRenderer.send('realtime-send-cancel'),
  sendUserInput: (text) => ipcRenderer.send('realtime-send-user-input', text),
});