const { registerInstrumentations } = require('@opentelemetry/instrumentation');
const { NodeTracerProvider } = require('@opentelemetry/tracing');
const { SimpleSpanProcessor } = require('@opentelemetry/tracing');
const { HttpExporter } = require('@opentelemetry/exporter-http');

const provider = new NodeTracerProvider();
provider.addSpanProcessor(new SimpleSpanProcessor(new HttpExporter({
  url: 'http://localhost:5768/sentry',
})));

registerInstrumentations({
  tracerProvider: provider,
  instrumentations: [
    require('@opentelemetry/instrumentation-node'),
    // Add other instrumentations as needed
  ],
});
