function tooltip_tool()
{
     // Tooltip function
     const tooltipButtons = document.querySelectorAll('.tooltip-button');
     
     tooltipButtons.forEach(button => {
       
         const tooltipText = document.createElement('div');
         tooltipText.classList.add('tooltip-text');
         tooltipText.textContent = button.getAttribute('data-tooltip');
         document.body.appendChild(tooltipText); // Append to body for fixed positioning relative to viewport
         
         button.addEventListener('mouseenter', function () {
            
             const rect = button.getBoundingClientRect();
             const tooltipRect = tooltipText.getBoundingClientRect();
             const viewportHeight = window.innerHeight;
 
             // Remove any existing position classes
             tooltipText.classList.remove('tooltip-top', 'tooltip-bottom');
 
             if (rect.top - tooltipRect.height - 10 < 0) {
                 // Position tooltip below the button
                 tooltipText.classList.add('tooltip-bottom');
                 tooltipText.style.top = `${rect.bottom + 10}px`;
                 tooltipText.style.bottom = 'auto';
             } else {
                 // Position tooltip above the button
                 tooltipText.classList.add('tooltip-top');
                 tooltipText.style.top = 'auto';
                 tooltipText.style.bottom = `${viewportHeight - rect.top + 10}px`;
             }
 
             tooltipText.style.left = `${rect.left + rect.width / 2}px`;
             tooltipText.style.transform = 'translateX(-50%)';
 
             // Show the tooltip
             tooltipText.style.visibility = 'visible';
             tooltipText.style.opacity = '1';
             tooltipText.style.transitionDelay = '0s';
         });
 
         button.addEventListener('mouseleave', function () {
             // Hide the tooltip with animation
             tooltipText.style.opacity = '0';
             tooltipText.style.visibility = 'hidden';
             tooltipText.style.transitionDelay = '0.3s'; // Match the transition duration
         });
     });
}