
function testSimpleCodeChanges(){
    console.log("testing simplme code changes");

    let origFile = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\renderer.js";
    let originalCode = fs.readFileSync(origFile, 'utf-8');  
    let newCode = `STUBS.loadSettings = async function(){
        storage.get('all_projects', function(error, data) {
            console.log("error");
            console.log(error);
            console.log("projects");
            console.log(data);

            if (data && data.all_projects) {
                data.all_projects.forEach(project => {
                    console.log('Project Name: ' + project.name);
                    console.log('Project Folder: ' + project.folder);
                    console.log('Project Description: ' + project.description);
                    console.log('LLM Rules: ' + project.llm_rules);
                    console.log('---');
                });
            }
        });     

        // ... existing code
    };`;

    let modFile = DIFFR.simpleCodeChanges(originalCode, newCode);
    console.log("afterwards file:");
    console.log(modFile);
    
}

$(document).ready(function () {
    $('#test_clear_all_projects').on('click', function() {
        storage.remove('all_projects', function(error) {
          if (error) throw error;
          console.log('All projects cleared successfully');
          // Refresh the project list or perform any other necessary actions
        });
    });

    //testSimpleCodeChanges();
    
    $('#test_loading_response').on('click', async function(){
        await mysqlLogger.initDatabase(mysqlConfig);   
        let theTask = await mysqlLogger.getLatestTaskByRequestType('do_new_programming_task');
        if(theTask){
            $('#chatgpt-request').val(theTask);
            setTimeout(function(){
                $('#send_button').trigger('click');                
            }, 100);
        }
        
        
        
    });
  
    $('#test_mysql_connection').on('click', async function() {
        /*
        let mysqlConfig = {
            host: 'ec2-107-23-253-169.compute-1.amazonaws.com',
            port: 3306,
            user: 'scrapeuser2',
            password: 'xxx',
            database: 'scrapehawk'
        };

        let isConnected = await mysqlConn.testConnection(mysqlConfig);
        if (isConnected) {
            console.log('MySQL connection successful');
        } else {
            console.log('MySQL connection failed');
        }
        */
       
       
        const connections = await ipcRenderer.invoke('get-connections');
        console.log('MySQL connections1111:');
        console.log(connections);
        console.log("length" + Object.keys(connections).length);
        if (Object.keys(connections).length > 0) {
            const connectionName = Object.keys(connections)[0];            
            const connection = connections[connectionName];

            if (!mysqlConn.databaseConnected) {
                console.log("initing database");
                let mysqlConfig = {
                    host: connection.host,
                    user: connection.user,
                    password: connection.password,
                    database: connection.database                    
                };
                await mysqlConn.initDatabase(mysqlConfig);
            }            
            const schemas = await mysqlConn.getSchemas();
            console.log('Schemas:', schemas);

            const defaultSchema = connection.database;
            const tables = await mysqlConn.getTables(defaultSchema);
            console.log(`Tables in schema ${defaultSchema}:`, tables);
        } else {
            console.log('No MySQL connections found');
        }            
        
    });  
  
    /*
    async function generateDependencies(projectName, finalOriginalPaths){


        let doesItWork = await DGRAPH.getDependenciesForProject(finalOriginalPaths);
        
        let dGraphArr = doesItWork[0];
        let dependencyGroups = doesItWork[1];
        console.log("graph count" + dGraphArr.length);
        
        
        console.log("saving graph");
        await dexieDB.saveDependencyGraph(projectName, dGraphArr);
        console.log("saving group");        
        await dexieDB.saveDependencyGroups(projectName, dependencyGroups);    
        console.log("generated dependencies");
        
        return doesItWork;
    }
    */
   
   $('#test_related_files').on('click', async function(){
        let relatedFiles = await DGRAPH.getRelatedFiles(lineNumberArr, myProjectArr[0]);
        for (let file of relatedFiles) {
            if (!stubFilesArr.includes(file)) {
                stubFilesArr.push(file);
            }
        }       
   });
   
   $('#test_formalize_changes').on('click', async function(){
       /*
       let formalizeId = 1577;
       let formlizeResponse = await mysqlLogger.getResponseById(formalizeId);
       console.log("formalize response");
       console.log(formlizeResponse);
       */
        let thePrompt = fs.readFileSync(path.join(STUBS.appPath, 'prompts', 'new_code_placement.txt'), 'utf-8');
        let stubFile = "TEST IT";
        let newCode = "newCode";
        let assistantMessage = "Ass Message";
        let fullPrompt = Mustache.render(thePrompt, {
            stubFile: stubFile,
            newCode: newCode,
            assistantMessage: assistantMessage
        });      
        
        console.log("FULL PROMPT RESULT");
        console.log(fullPrompt);
        
      
   });
   
   $('#load_idapply').on('click', async function(){
        const replayId = $('#replay_id').val();
        let tabUid = TABS.getCurrentUid();
        let tabIndex = TABS.getIndexByUid(tabUid);   
        
        if (replayId) {
            const applyChangesLog = await mysqlLogger.getApplyChangesById(replayId);
            console.log('Apply Changes Log:', applyChangesLog);
            // Parse the stored JSON strings
            const allRelevantText = applyChangesLog.all_relevant_text;
            const assistantMessage = applyChangesLog.assistant_message;
            //const finalOriginalPaths = JSON.parse(applyChangesLog.final_original_paths);
            let finalShortPaths = JSON.parse(applyChangesLog.final_short_paths);
 
         
            
            const justFilesLinux = JSON.parse(applyChangesLog.just_files_linux);
            const myProjectData = JSON.parse(applyChangesLog.my_project_data);
            const filesSnapshot = JSON.parse(applyChangesLog.files_snapshot);

            // Extract myProjectArr, myProjectPathArr, and myProjectDescArr from myProjectData
            const { my_project_arr: myProjectArr, my_project_path_arr: myProjectPathArr, my_project_desc_arr: myProjectDescArr } = myProjectData;
            
            STUBS.APPLY_FILE_OVERRIDES = filesSnapshot;
             let {checkedProjects, checkedProjectPaths, checkedProjectDescriptions} = SFILE.getCheckedProjects();   
            let replaceProjectPath = myProjectPathArr[0];
            for(let snapKey in filesSnapshot){
                console.log("snapkey " + snapKey);
                console.log("replacing " + replaceProjectPath);
                console.log("with " + checkedProjects[0]);
                let origSnapKey = snapKey;
                snapKey = replaceAll(snapKey, replaceProjectPath, checkedProjectPaths[0]);
                console.log("updated key: ");
                console.log(snapKey);
                //console.log("snapcontent " + filesSnapshot[snapKey]);
                STUBS.FILE_CACHE.set(snapKey, filesSnapshot[origSnapKey]);
            }
            
           
            
            let CHANGE_MY_PROJECT_NAME = checkedProjects[0];
            let CHANGE_MY_PROJECT_PATH = checkedProjectPaths[0];
            let CHANGE_MY_PROJECT_DESC = checkedProjectDescriptions[0];
            
            
            let finalOriginalPaths = finalShortPaths.map(shortPath => path.join(CHANGE_MY_PROJECT_PATH, shortPath));    
            
            console.log("final short paths");
            console.log(finalShortPaths);
            console.log("finalOriginalPaths");
            console.log(finalOriginalPaths);            
            
            
            //SAVE ID of doNewProgrammingTask to get this???
            //NO TASK NEEDED?
            //NO TASK NEEDED?
            //NO TASK NEEDED?
            
            let myTask = "";

            let changesSucceeded = false;
            //
            // Determine which apply changes method to use (you may want to add a way to select this)
            if (STUBS.APPLY_CHANGES_BY === 'piecemeal') {
                STUI.updateLoaderText("Applying Changes (Piecemeal)");
//applyPiecemealCodeChanges(tabUid, assistantMessage, finalOriginalPaths, finalShortPaths, justFilesLinux, myProjectArr, myProjectPathArr, myProjectDescArr, existingEditors = null) {
                
                changesSucceeded = await applyPiecemealCodeChanges(tabUid, assistantMessage, finalOriginalPaths, finalShortPaths, justFilesLinux, checkedProjects, checkedProjectPaths, checkedProjectDescriptions);
                $('#reapply_changes').html("Redo w Formalize");
            } else if (STUBS.APPLY_CHANGES_BY === 'simple') {
                STUI.updateLoaderText("Applying Changes (SIMPLE)");
                changesSucceeded = await applySimpleCodeChanges(tabUid, assistantMessage, finalOriginalPaths, finalShortPaths, justFilesLinux, CHANGE_MY_PROJECT_NAME, CHANGE_MY_PROJECT_PATH);
            } else if (STUBS.APPLY_CHANGES_BY === 'formalized') {
                STUI.updateLoaderText("Applying Changes (Formalized)");
                $('#reapply_changes').html("Redo w Piecemeal");
                console.log("REAPPLYING CHANGES");
                console.log(myProjectArr);
                console.log(myProjectPathArr);
                console.log(myTask);
                console.log(tabUid);
                console.log(allRelevantText);
                console.log(assistantMessage);
                
                changesSucceeded = reapplyUsingFormalizedChanges(myProjectArr, myProjectPathArr, myTask, tabUid, allRelevantText, assistantMessage);        
            } else {
                alert("Unknown application method");
            }

            STUI.stopLoader();
            $('#reapply_changes').css('display', 'block');     
            if (changesSucceeded) {
                STUBS.CURRENT_TASK_COUNT++;
                $('#task_count').text(STUBS.CURRENT_TASK_COUNT);       
            } else {
                STUI.loaderError("Error Applying Changes");
            }            
            
            
        } else {
            console.log('Please enter a valid replay ID.');       
        }
   });
    
    $('#test_file_descriptions').on('click', async function(){
      
      if(!STUBS.STUBS_LOADED){
          alert("Please wait a second for Stub files to be generated/synced");
          return;
      }
      let projectName = "Stubs";
      let {checkedProjects, checkedProjectPaths} = SFILE.getCheckedProjects();  
       
      let projectDesc = "Electron node.js application that allows you to request code completion tasks from LLMs, and provides an interface to approve those code changes.";    
      let projectPath = checkedProjectPaths[0];
      
        let isReady = await EMBED.embeddingsReadyOrCreate(projectName, projectDesc, projectPath);
        if(isReady){
            let documents = await EMBED.getDocumentsArray();
            let onlyFilepaths = new Array();
            for(let f = 0; f < documents.length; f++){
                onlyFilepaths.push(documents[f]['filename']);
            }
            console.log("document array");
            console.log(documents);
            
            //adfksljlasdfljsdfsadflkj dasflj adfslkasfjlfasd jdsfalj sdf
            
            const embeddings = await ipcRenderer.invoke('generateEmbeddings', documents);
            await dexieDB.saveEmbeddingsToDexie(projectName, embeddings, onlyFilepaths);        
        }else{
            console.log("not ready");
        }
        /*
        let docs = new Array();
        
        
        for(let x = 0; x < finalOriginalPaths.length; x++){
            
            let fPath = finalOriginalPaths[x];
            let sPath = finalShortPaths[x];
            let theDescription = "";
            let depArr = new Array();
            let codeContent = await fs.readFile(fPath, 'utf8');
            let foundDesc = false;
            for(let m = 0; m < existingDescriptions.length; m++){
                let myPath = existingDescriptions[m].file_path;
                if(!myPath){
                    continue;
                }
                if(comparePaths(myPath, sPath)){
                    foundDesc = true;
                    theDescription = existingDescriptions[m].description;
                }
            }
            let foundDepArr = false;
            for(let d = 0; d < existingDependencies.length; d++){
                let shortDepPath = path.normalize(existingDependencies[d].filepath.replace(checkProjectPath, '')).replace(/\\/g, '/');
                console.log("short dep path");
                console.log(shortDepPath);
                if(comparePaths(shortDepPath, sPath)){
                    foundDepArr = true;
                    depArr = existingDependencies[d].dependencyLines;
                }                                                
            }
            if(!foundDesc){
                console.log("DESCRIPTIONS - DID NOT FIND " + sPath);
            }
            if(!foundDepArr){
                console.log("DEPENDENCIES - DID NOT FIND " + sPath);
            }
            

            let theCode = "";
            let newDoc = {filename: sPath,
                code: codeContent, 
                description: theDescription,
                dependencies: depArr
            };
            docs.push(newDoc);
            
            if(x > 3){
                break;
            }
            //`${doc.filename}\n${doc.description}\n${doc.dependencies.join("\n")}`;
        }
        
        console.log("Embedding Docs");
        console.log(docs);
                
        let theEmbeddings = xEmbeddings.generateEmbeddings(projectName, docs);
        */
        
        //let documents = await EMBED.getDocumentsArray(checkProjectPath, finalOriginalPaths, finalShortPaths, existingDependencies, existingDescriptions);
        //console.log("Done Embedding DOCS");
        //console.log(theEmbeddings);
        //
        
        //await dexieDB.saveEmbeddingsToDexie(projectName, theEmbeddings);
        
        

    });
    
    
    $('#test_step1_embeddings').on('click', async function(){
        //testSimpleEmbeddings();
        
    
        console.log("testing getting embeddings");
        const embeddings = await dexieDB.getEmbeddingsFromDexie("Stubs");
        console.log("got embeddings");
        console.log(embeddings);
        
        let allVectorData = new Array();
        let allFilePaths = new Array();
        for(let x = 0; x < embeddings.length; x++){
            allVectorData.push(embeddings[x]['vector_data']);
            allFilePaths.push(embeddings[x]['filename']);
        }

        console.log("vector data");
        console.log(allVectorData);
        console.log("docFiles");
        console.log(allFilePaths);
        
        
        let projectName = "Stubs";
        let projectDesc = "Electron node.js application that allows you to request code completion tasks from LLMs, and provides an interface to approve those code changes.";
        let query = "The redo button should bring back the #chatgpt-request-container and allow editing.  It should hide the .replace_chatgpt_request because that was added for when a request was sent.  The code for this should be in  index.html and ui_handlers.js Then what it does is clear out any variables there were saved in the tabmanager for that tab and remove the chatgpt response container, so then when press the send button it does fullNewTask again.";
        const mostSimilarIndices = await ipcRenderer.invoke('findMostSimilarDocumentIndices', query, allVectorData, 5);
        let mostSimilarDocuments = mostSimilarIndices.map((index) => allFilePaths[index]);        
        
        console.log("most similar");
        console.log(mostSimilarDocuments);
        
    });
    
    $('#test_newapi').on('click', function(){
        CHATGPT.testStreaming();
    });
    
    $('#test_start_debugger').on('click', async function(){
        console.log("sentry server initiate");
        ipcRenderer.send('setupDebugListener');
        
        setTimeout(function(){
            console.log("starting sentry in renderer");
            initializeDebugLogger('stubs');
        }, 1000);

        let thePrompt = fs.readFileSync(path.join(STUBS.appPath, 'prompts', 'request_architecture_topology.txt'), 'utf-8');

        let stubFilesTxt = "Test Files";
        let depGraphTxt = "Test Dependencies";

        fullPrompt = Mustache.render(thePrompt, {
            stubFiles: stubFilesTxt,
            dependencyGraphPrintout: depGraphTxt
        });        
        
    });
    
    
    $('#test_completion').on('click', function(){
       let theTask = "Can you tell me what this unix time is in human readable format: " + new Date().getTime().toString();
       CHATGPT.testNormalCompletion(theTask);
    });
    
    
    $('#test_get_filetext').on('click', async function(){
        let assistantMessage = `|js/chatgpt.js|
 CHATGPT.updateHtmlText = async function(newText, tabUid){
 CHATGPT.postProcessHtmlText = function(outputHtml, tabUid){
 CHATGPT.finalizeHtmlText = function(tabUid){
 
 |views/chat_response_container.html|
 <div id="chatgptresponse_{{tabUID}}" class="chatgpt-response"></div>
 
 |css/styles.css|
 .chatgpt-response-container
 .chatgpt-response
 .copybuttoncontainer
 .copy-button`;
        
        let lineNumberArr = CHATGPT.parseStubFileLines(assistantMessage); 
        let {checkedProjects, checkedProjectPaths, checkedProjectDescriptions} = SFILE.getCheckedProjects();      
        
        let projectFileData = await SFILE.getAvailableFilesForGPT(checkedProjects, STUBS.stubsData);   
        console.log("project file data");
        console.log(projectFileData);
        
        let CHANGE_MY_PROJECT_NAME = checkedProjects[0];
        console.log("project name");
        console.log(CHANGE_MY_PROJECT_NAME);

        let fileRefText = await CHATGPT.parseLineNumbers(lineNumberArr, CHANGE_MY_PROJECT_NAME, STUBS.stubsData);
        //console.log("Final context data");    
        //console.log(fileRefText);
        //await gotosleep(2000);      
        let allRelevantText = fileRefText['all_relevant_text'];
        let allFileData = fileRefText['all_data'];

        let badLines = fileRefText['bad_lines'];
        
        console.log("TESTING GETTING RELEVANT TEXT FROM");
        console.log(assistantMessage);
        
        console.log("RELEVANT");
        console.log(allRelevantText);        
        
        //mysqlLogger.getResponseByRequestTypeAndUid();
    });
    
    
    $('#test_code_parsing').on('click', async function(){
        
        let assistantMessage = fs.readFileSync(path.join(STUBS.appPath, 'treetest', 'php', 'old', 'assistantMessage1.txt'), 'utf-8');
        let assistantMessage2 = fs.readFileSync(path.join(STUBS.appPath, 'treetest', 'javascript', 'old', 'assistantMessage2.txt'), 'utf-8');        
        let assistantMessage3 = fs.readFileSync(path.join(STUBS.appPath, 'treetest', 'python', 'old', 'assistantMessage3.txt'), 'utf-8');     
        
        let justFilesLinux = ['framework/libs/output.php', 'framework/views/home.tpl', 'index.php'];        
        let allCodeChanges = DIFFR.parseCodeChanges(assistantMessage, justFilesLinux);
        
        console.log("testing all code changes");
        console.log(allCodeChanges);
        
      
        let justFilesLinux2 = ['js/ui_handlers.js', 'js/dexiedatabase.js', 'js/ui_modal_handlers.js', 'js/mydatabase.js', 'main.js', 'index.html'];        
        let allCodeChanges2 = DIFFR.parseCodeChanges(assistantMessage2, justFilesLinux2);
        console.log("testing all code changes");
        console.log(allCodeChanges2);        
        
        let justFilesLinux3 = ['main.py', 'ffmpeg.py', 'cwscraper/CWScraper.py'];
        let allCodeChangesPython = DIFFR.parseCodeChanges(assistantMessage3, justFilesLinux3);
        console.log("testing all code changes");
        console.log(allCodeChangesPython);                
        
        
    });
    
    
    $('#test_scope_creation').on('click', async function(){

        console.log("======================   TESTING SCOPE CREATION ===========================");        
        console.log("============================================================================");
        console.log("============================================================================");        
        console.log("============================================================================");        
        console.log("============================================================================");        
        console.log("============================================================================");        
        console.log("============================================================================");        
        
        let test = fs.readFileSync(path.join(STUBS.appPath, 'treetest', 'javascript', 'old', 'scope1.txt'), 'utf-8');  
        
        let test2 = ``;
        
        let test4 = ``;

        let test5 = fs.readFileSync(path.join(STUBS.appPath, 'treetest', 'javascript', 'old', 'scope5.txt'), 'utf-8');   
        let testFile5 = 'C:\\wamp\\www\\videomonitor\\video-monitor\\main.py';
        let testFileContent5 = fs.readFileSync(testFile5, 'utf-8');  
        
        var testCodeBlock = async function(codeBlock, file, fileContent){
            console.log("getting scopes");
            console.log(codeBlock);
            let theScopes = await DGRAPH.getTopLevelScopes(codeBlock, file, fileContent);        
            console.log("scopes");
            console.log(theScopes);        
        };

        await testCodeBlock(test5, 'main.py', testFileContent5);
        
        //await testCodeBlock(test, 'myfile.js');
        //await testCodeBlock(test2, 'myfile.js');
        //await testCodeBlock(test3, 'testFile.php');
        
        //let desiredScopes = [1, [{start_line: "db.version(1).stores({", total_lines: 12}]];
        //await testCodeBlock(test4, 'anotherfile.js');
        //await testCodeBlock(test5, 'anotherfile.js');
        //await testCodeBlock(test6, 'test.php');
        //await testCodeBlock(test7, 'index.php');
        //await testCodeBlock(test8, 'framework\classes\documentation.php');
    });
    
        
    $('#language_parsing_test').on('click', async function() {
      const fs = require('fs');
      const path = require('path');

      // Ensure that STUBS.appPath is defined
      if (typeof STUBS === 'undefined' || !STUBS.appPath) {
        console.error('STUBS.appPath is not defined.');
        return;
      }

      let answerKey = {
          'javascript': {
            'doheap': {
              'codeChanges': [16] // Expected number of scopes for each code change
            },
            // ... other tasks
          },
          // ... other languages
      };
      
        // Array of languages to test
       // const languagesToTest = ['c', 'c_sharp', 'cpp', 'dart', 'elm', 'go', 'java', 'javascript','lua','php','python','ruby','rust','typescript', 'kotlin', 'swift'];      
        const languagesToTest = ['javascript'];
      const treetestDir = path.join(STUBS.appPath, 'treetest');
      let languageDirs;

      try {
        languageDirs = fs.readdirSync(treetestDir).filter(f => fs.statSync(path.join(treetestDir, f)).isDirectory());
      } catch (err) {
        console.error('Error reading treetest directory:', err);
        return;
      }

      // For storing test results
      const testResults = [];
      
      const filteredLanguageDirs = languageDirs.filter(dir => languagesToTest.includes(dir.toLowerCase()));


      for (let languageDirName of filteredLanguageDirs) {
        const languageDir = path.join(treetestDir, languageDirName);
        let files;

        try {
          files = fs.readdirSync(languageDir);
        } catch (err) {
          console.error(`Error reading directory ${languageDirName}:`, err);
          continue;
        }

        // Find sorting.EXT file
        let sortingFile = files.find(f => f.startsWith('sorting.'));
        if (!sortingFile) {
          console.log(`No sorting file found in ${languageDirName}`);
          continue;
        }

        const sortingFilePath = path.join(languageDir, sortingFile);
        let sortingFileContent;

        try {
          sortingFileContent = fs.readFileSync(sortingFilePath, 'utf-8');
        } catch (err) {
          console.error(`Error reading sorting file in ${languageDirName}:`, err);
          continue;
        }

        // Get existing filenames - in this case, maybe just sortingFile
        const existingFilenames = [sortingFile];

        // Get 'resp_' files
        const respFiles = files.filter(f => f.startsWith('resp_'));
        if (respFiles.length === 0) {
          console.log(`No resp_ files found in ${languageDirName}`);
          continue;
        }

        for (let respFile of respFiles) {
          const respFilePath = path.join(languageDir, respFile);
          let assistantMessage;

          try {
            assistantMessage = fs.readFileSync(respFilePath, 'utf-8');
          } catch (err) {
            console.error(`Error reading resp file ${respFile} in ${languageDirName}:`, err);
            continue;
          }

          // Extract task name from resp_*.txt filename
          const taskNameMatch = respFile.match(/^resp_(.+)\.txt$/);
          let taskName = '';
          if (taskNameMatch) {
            taskName = taskNameMatch[1];
          } else {
            console.log(`Could not extract task name from ${respFile}, proceeding without verification.`);
            // Proceed without verification
          }

          // Get expected values from answer key if available
          const languageAnswerKey = answerKey[languageDirName] || {};
          const taskAnswerKey = languageAnswerKey[taskName] || {};
          const expectedCodeChanges = taskAnswerKey.codeChanges || null;

          // Pass assistantMessage and existingFilenames to DIFFR.parseCodeChanges()
          const allCodeChanges = DIFFR.parseCodeChanges(assistantMessage, existingFilenames);
          console.log("CODE CHANGES");
          console.log(allCodeChanges);
          

          console.log(`\nTesting language: ${languageDirName}, task: ${taskName || 'Unknown Task'}`);
          if (expectedCodeChanges) {
            console.log(`Expected number of code changes: ${expectedCodeChanges.length}`);
          }
          console.log(`Actual number of code changes: ${allCodeChanges.length}`);

          let testPassed = true;

          if (expectedCodeChanges && allCodeChanges.length !== expectedCodeChanges.length) {
            //console.error(`Test failed for ${languageDirName} task ${taskName}: Expected ${expectedCodeChanges.length} code changes, got ${allCodeChanges.length}`);
            testPassed = false;
          }

          // For each code change
          for (let i = 0; i < allCodeChanges.length; i++) {
            const codeChange = allCodeChanges[i];
            const codeBlock = codeChange.code_changes;
            const file = codeChange.file_path;

            // Get the file content
            const fileContentPath = path.join(languageDir, file);
            let fileContent = '';

            try {
              fileContent = fs.readFileSync(fileContentPath, 'utf-8');
            } catch (err) {
              console.log(`Could not read file content for ${file} in ${languageDirName}:`, err);
              testPassed = false;
              continue;
            }

            // Pass codeBlock, file, fileContent to DGRAPH.getTopLevelScopes()
            let scopes;
            try {
              scopes = await DGRAPH.getTopLevelScopes(codeBlock, file, fileContent);
              console.log("ALL SCOPES FOR CHANGE " + i);
              console.log(scopes);              
              
            } catch (err) {
              console.error(`Error getting top-level scopes for ${file} in ${languageDirName}:`, err);
              testPassed = false;
              continue;
            }

            console.log(`\nCode change ${i + 1}:`);
            if (expectedCodeChanges) {
              const expectedNumScopes = expectedCodeChanges[i];
              console.log(`Expected number of scopes: ${expectedNumScopes}`);
            }
            console.log(`Actual number of scopes: ${scopes.length}`);
            console.log('Scopes:', scopes);

            // Verification if expected values are provided
            if (expectedCodeChanges) {
              const expectedNumScopes = expectedCodeChanges[i];
              const actualNumScopes = scopes.length;

              if (actualNumScopes !== expectedNumScopes) {
                console.error(`Test failed for code change ${i + 1} in ${languageDirName} task ${taskName}: Expected ${expectedNumScopes} scopes, got ${actualNumScopes}`);
                testPassed = false;
              }
            }
          }

          // Only push test results if expected values were provided
          if (expectedCodeChanges) {
            testResults.push({
              language: languageDirName,
              task: taskName,
              passed: testPassed
            });

            if (testPassed) {
              console.log(`Test passed for ${languageDirName} task ${taskName}`);
            } else {
              console.log(`Test failed for ${languageDirName} task ${taskName}`);
            }
          } else {
            console.log(`Verification skipped for ${languageDirName} task ${taskName} due to missing expected results.`);
          }
        }
      }

      // After all tests, you can display a summary
      if (testResults.length > 0) {
        console.log('\nTest Summary:');
        testResults.forEach(result => {
          console.log(`${result.language} - ${result.task}: ${result.passed ? 'Passed' : 'Failed'}`);
        });
      } else {
        console.log('\nNo tests were verified due to missing expected results.');
      }
    });

    $('#language_create_stubs').on('click', async function() {
        const fs = require('fs');
        const path = require('path');

        // Ensure that STUBS.appPath is defined
        if (typeof STUBS === 'undefined' || !STUBS.appPath) {
            console.error('STUBS.appPath is not defined.');
            return;
        }

        const treetestDir = path.join(STUBS.appPath, 'treetest');

        // Get the list of language directories
        let languageDirs;
        try {
            languageDirs = fs.readdirSync(treetestDir).filter(f => fs.statSync(path.join(treetestDir, f)).isDirectory());
        } catch (err) {
            console.error('Error reading treetest directory:', err);
            return;
        }

        // For each language directory
        for (let languageDirName of languageDirs) {
            const languageDirPath = path.join(treetestDir, languageDirName);
            let files;

            try {
                files = fs.readdirSync(languageDirPath);
            } catch (err) {
                console.error(`Error reading directory ${languageDirName}:`, err);
                continue;
            }

            // Find the sorting.EXT file
            let sortingFile = files.find(f => f.startsWith('sorting.'));
            if (!sortingFile) {
                console.log(`No sorting file found in ${languageDirName}`);
                continue;
            }

            const sortingFilePath = path.join(languageDirPath, sortingFile);

            // Run it through the stub creation function
            // Wrap TREESIT.getFileStub in a Promise to use with async/await
            const getFileStubPromise = (filePath) => {
                return new Promise((resolve, reject) => {
                    TREESIT.getFileStub(filePath, 'xxx', false, function(finalText) {
                        if (finalText) {
                            resolve(finalText);
                        } else {
                            reject(`Error generating stub for ${filePath}`);
                        }
                    });
                });
            };

            try {
                const finalText = await getFileStubPromise(sortingFilePath);

                // Write the output to "stubfile.txt" in the language directory
                const stubFilePath = path.join(languageDirPath, 'stubfile.txt');

                fs.writeFileSync(stubFilePath, finalText);
                console.log(`Stub file written to ${stubFilePath}`);
            } catch (err) {
                console.error(`Error processing ${sortingFilePath}:`, err);
                continue;
            }
        }
    });

    
    $('#test_markup_scope').on('click', async function(){
                
        let test1 = `// framework\views\header.tpl
//...

{if isset($base_href) && $base_href !== null}
    <base href="{$base_href->value}">
{/if}

//...`;
        
        let test2 = `//...
{if isset($market_alerts) && !empty($market_alerts)}
    {foreach from=$market_alerts item=malert}
    <div class="market-alert-container">
        <div class="lg-col-wrapper">
            <i class="market-alert-close fa fa-times-circle" aria-hidden="true"></i>
            <div class="market-alert-text">
                {$malert['message']}
            </div>
        </div>
    </div>
    {/foreach}
{/if}
<div id="mixedcontent"><span>What
        </span><ul>
        <li>adfsfsd</li>
        </ul>
    </div>
{foreach from="hey" item=what}
        <span>{$what}</span
{/foreach}
//...`;  
        var testMarkupBlock = async function(codeBlock, filename){
            console.log("getting scopes");
            console.log(codeBlock);
            let theScopes = await WEBFILE.getTopLevelMarkupScopes2(codeBlock, filename);
            console.log("scopes");
            console.log(theScopes);        
        };           
        
        console.log("TESTING MARKUP SCOPES, test 1");
        await testMarkupBlock(test1, 'framework\views\header.tpl');
        console.log("TESTING MARKUP SCOPES, test 2");        
        await testMarkupBlock(test2, 'framework\views\header.tpl');        
         
    });
    
    
    
    $('#test_line_structure').on('click', async function(){
        /*
        let testLine1 = 'for(let x = 0; x < groupOriginalPaths.length; x++){';
        let testFile1 = 'C:\\wamp\\www\\stubs\\stubs-ai-assistant\\js\\embeddings.js';
        let testFilePath1 = 'js/embeddings.js';
        let testFileContent1 = fs.readFileSync(testFile1, 'utf-8');  
        
        let testLine2 = 'db.version(1).stores({';
        let testFile2 = 'C:\\wamp\\www\\stubs\\stubs-ai-assistant\\js\\dexiedatabase.js';
        let testFilePath2 = 'js/dexiedatabase.js';
        let testFileContent2 = fs.readFileSync(testFile2, 'utf-8');          
        
        let testLine3 = 'CHATGPT.singleFilePartialChange = async function(filePath, partialOriginal, assistantMessage, tabUid){';
        let testFile3 = 'C:\\wamp\\www\\stubs\\stubs-ai-assistant\\js\\chatgpt.js';
        let testFilePath3 = 'js/chatgpt.js';
        let testFileContent3 = fs.readFileSync(testFile3, 'utf-8');          
        
        let testLine4 = "$('body').on('click', '#show_history', async function(){";
        let testFile4 = 'C:\\wamp\\www\\stubs\\stubs-ai-assistant\\js\\ui_handlers.js';
        let testFilePath4 = 'js/ui_handlers.js';
        let testFileContent4 = fs.readFileSync(testFile4, 'utf-8');          
                
       
        let largestControl = await DGRAPH.getLargestControlStructureForLine(testFilePath1, testLine1, testFileContent1);        
        console.log("TEST1 largest control structure");
        console.log(largestControl);                

        let largestControl2 = await DGRAPH.getLargestControlStructureForLine(testFilePath2, testLine2, testFileContent2);        
        console.log("TEST2 largest control structure");
        console.log(largestControl2);                
        
        let largestControl3 = await DGRAPH.getLargestControlStructureForLine(testFilePath3, testLine3, testFileContent3);        
        console.log("TEST3 largest control structure");
        console.log(largestControl3);           
        
        let largestControl4 = await DGRAPH.getLargestControlStructureForLine(testFilePath4, testLine4, testFileContent4);        
        console.log("TEST4 largest control structure");
        console.log(largestControl4);           
        */
        let testLine5 = 'public function test_services_login(){';
        let testFile5 = 'C:\\wamp\\www\\localnews\\localnews\\framework\\classes\\cron.php';
        let testFilePath5 = 'cron.php';
        let testFileContent5 = fs.readFileSync(testFile5, 'utf-8');        
        let largestControl5 = await DGRAPH.getLargestControlStructureForLine(testFilePath5, testLine5, testFileContent5);        
        console.log("TEST5 largest control structure");
        console.log(largestControl5);    
        
    });
    
    $("#test_treesit_html").on('click', async function(){
        //C:\wamp\www\stubs\stubs\framework\views\user\dashboard.tpl
        let origFile = "C:\\wamp\\www\\stubs\\stubs\\framework\\views\\user\\dashboard.tpl";
        let originalCode = fs.readFileSync(origFile, 'utf-8');  
        
        const lineCount = originalCode.split('\n').length;
        const allLines = originalCode.split('\n');
        
        for(let m = 0; m <= lineCount - 1; m++){
            /*
            console.log("=============");            
            console.log("at line " + m);
            let result = await TREESIT.getHtmlElementScopeForLine(originalCode, m, "tpl");
            console.log("treesit result");
            console.log(result);
            */
            console.log("=============");           
            let startLine = allLines[m];
            // Skip lines that start with </
            if(startLine.startsWith('</') || startLine.trim() == ''){
                continue;
            }            
            console.log("line" + m);
            console.log(startLine);
            console.log("WEBFILE RESULT ");
            let fallbackResult = await WEBFILE.getMarkupScopeFallback(originalCode, m + 1, ".tpl");
            console.log(fallbackResult);
            console.log("=============");

        }
    });
    
    
});

async function testSimpleEmbeddings(){
const documents = [
      {
        filename: "utility.js",
        description: "This file contains utility functions for string manipulation.",
        dependencies: [
          "file1.js calls function_x from utils.js",
          "file2.js calls function_y from file1.js",
        ],
      },
      {
        filename: "authorize.js",
        description: "This file handles user authentication and authorization.",
        dependencies: [
          "authorize.js calls function_y from utility.js",
          "authorize.js calls function_z from utility.js",
        ],
      },
      {
        filename: "ui_handlers.js",
        description: "This file handles setting up the UI.",
        dependencies: [
          "ui_handlers.js calls get_widgets() from utility.js",
          "ui_handlers.js calls get_layout() from utility.js",
        ],
      },  
    ];        
      const embeddings = await ipcRenderer.invoke('generateEmbeddings', documents);
      const query = "Find files related to building the UI";
      const mostSimilarIndices = await ipcRenderer.invoke('findMostSimilarDocumentIndices', query, embeddings, 3);
      let mostSimilarDocuments = mostSimilarIndices.map((index) => documents[index]);
      console.log("Most similar documents:", mostSimilarDocuments);    
}








//let uid = generateUID();
//console.log("test uid " + uid);

/*

*/

//random test code confusing things

/*
setTimeout(function(){
    console.log("Testing crawl Parser");
    CRAWL.testMarkdownConversion();
}, 1000);
 */

//for when I have modals
/*
document.addEventListener('DOMContentLoaded', () => {
  // Array of modal file paths
  const modalFiles = ['modals/settings_modal.html', 'modals/another_modal.html'];

  // Load and insert each modal file
  modalFiles.forEach(file => {
    fetch(file)
      .then(response => response.text())
      .then(html => {
        const body = document.querySelector('body');
        body.insertAdjacentHTML('beforeend', html);
      })
      .catch(error => {
        console.error('Error loading modal:', error);
      });
  });
});
*/

/*
async function testEmbeddings() {
  const documents = [
    {
      filename: "utility.js",
      description: "This file contains utility functions for string manipulation.",
      dependencies: [
        "file1.js calls function_x from utils.js",
        "file2.js calls function_y from file1.js",
      ],
    },
    {
      filename: "authorize.js",
      description: "This file handles user authentication and authorization.",
      dependencies: [
        "authorize.js calls function_y from utility.js",
        "authorize.js calls function_z from utility.js",
      ],
    },
    {
      filename: "ui_handlers.js",
      description: "This file handles setting up the UI.",
      dependencies: [
        "ui_handlers.js calls get_widgets() from utility.js",
        "ui_handlers.js calls get_layout() from utility.js",
      ],
    },
  ];

  try {
    const embeddings = await ipcRenderer.invoke('generateEmbeddings', documents);
    const query = "Find files related to building the UI";
    const mostSimilarIndices = await ipcRenderer.invoke('findMostSimilarDocumentIndices', query, embeddings, 3);
    //let mostSimilarDocuments = mostSimilarIndices.map((index) => documents[index]);
    console.log("Most similar indices:", mostSimilarIndices);
  } catch (error) {
    console.error('Error:', error);
  }
}

testEmbeddings();
*/

/*
let assistantMessage = `Here are the changes needed to complete the task:
 
 js\ui_handlers.js:
 
 \`\`\`javascript
 $(document).ready(function () {
   // ... existing code
   
   $('#add_link_context').on('click', function() {
     tippy(this, {
       content: \`
         <div>
           <input type="text" id="link_input" placeholder="Enter link">
           <button id="add_link_button">Add</button>
         </div>
       \`,
       interactive: true,
       trigger: 'click',
       allowHTML: true,
       onShow(instance) {
         const addButton = document.getElementById('add_link_button');
         addButton.addEventListener('click', () => {
           const linkInput = document.getElementById('link_input');
           const linkValue = linkInput.value;
           
           // Add the link to the current tab object
           const currentTab = TABS.TAB_ARR[TABS.CURRENT_INDEX];
           currentTab.link = linkValue;
           
           instance.hide();
         });
       }
     });
   });
   
   // ... existing code
 });
 \`\`\`
 
 js\tabmanager.js:
 
 \`\`\`javascript
 var TABS = TABS || {};
 
 TABS.CURRENT_INDEX = 0;
 TABS.CURRENT_UID = "";
 TABS.TAB_ARR = new Array();
 
 // ... existing code
 
 TABS.ADD_NEW_TAB = function(){
   // ... existing code
   
   let tabObject = {
     // ... existing properties
     link: "", // Add the link property to the tab object
     // ... existing properties
   };
   
   // ... existing code
 };
 
 // ... existing code
 \`\`\`
 
 These changes will:
 
 1. Add a click event listener to the \`add_link_context\` button.
 2. When clicked, show a tooltip using Tippy.js with a text field and an "Add" button.
 3. When the "Add" button in the tooltip is clicked, retrieve the link value from the text field and add it to the \`link\` property of the current tab object in \`TABS.TAB_ARR\`.
 4. Add the \`link\` property to the \`tabObject\` in the \`TABS.ADD_NEW_TAB\` function to ensure each new tab has a \`link\` property.
 
 With these changes, clicking the link button will show a tooltip where you can enter a link, and clicking the "Add" button will add the link to the current tab object.`;

setTimeout(function(){
    console.log("testssssss");
    let codeChanges = DIFFR.parseCodeChanges(assistantMessage);
    console.log("code changes test");
    console.log(codeChanges);    
}, 3000);
*/


/*
async function testParser(){
    let fileSmarty = "C:\\wamp\\www\\stubs\\stubs\\framework\\views\\home.tpl";
    let origData = readFileWithCache(fileSmarty);
    await STUBS.gotosleep(5000);
    console.log("testing invalid smarty file");
    console.log(origData);
    
    if (WEBFILE.quickHtmlValidate(origData)) {
         console.log("valid file");
    }else{
        console.log("invalid file");
    }
}
            setTimeout(function(){
                testParser();
            }, 1000);
*/




/*
async function testTreesitHtml(){
        console.log("getting control structure for html");

let fullFileData = `<div id="app-container">
    <div id="title-bar">
      <div id="title">Stubs - Supervised AI Autopilot</div>
      <div id="title-bar-btns">
        <button id="min-btn">-</button>
        <button id="max-btn">+</button>
        <button id="close-btn">x</button>
      </div>
    </div>
    <div id="file-menu">
      <ul>
        <li>
          <div class="file-menu-item">
            File
            <div class="file-dropdown">
              <a href="#" id="menu-add-project">Add New Project</a>
            </div>
          </div>
        </li>
        <li>
          <div class="file-menu-item">Edit
            <div class="file-dropdown">
              <a href="#" id="menu-settings">Settings</a> 
              <a href="#" id="menu-upgrade">Upgrade to Pro</a> 
            </div> 
          </div>
        </li>
        <li>
          <div class="file-menu-item">Tools
            <div class="file-dropdown">
              <a href="#" id="menu-planner">Feature Planner</a>                
              <a href="#" id="menu-debugger">Debugger</a>
              <a href="#" id="menu-database">Database</a>     
              <a href="#" id="menu-stubfiles">Stub Files</a>     
            </div>     
          </div>
        </li>        
        <li>
          <div class="file-menu-item">Help
            <div class="file-dropdown">
              <a href="#" id="menu-about">About</a>                
              <a href="#" id="menu-tutorial">Tutorial</a>
            </div>     
          </div>
        </li>        
      </ul>
      <div class="stubs_cost-container">
        <div class="day_cost">
          <span id="cost_label">Last 24h Cost</span> (estimate): <span id="today_cost">$0</span>
        </div>
        |
        <div class="day_tasks">
            Task Count: <span id="task_count">0</span>
        </div>      
      </div>
    </div>
   
    <div class="stubscontainer">
      <div class="main-content" id="dragmain-content">
        <div class="top-content" id="dragtop-content">
            <div style="display: flex;height: 100%;width: 100%;">
              <div>
                <div class="left-panel go_pro stubs_scroll-cus">
                  <div class="left-panel-rows">                    
                    <div class="button-panel">
                      <div class="next-button">
                      </div>                       
                    </div>
                  </div> 
                  <div id="progress-container">                      
                  </div>
                  <div id="directory-tree"></div>
                  <div></div>
                </div>
                <br><br><br>
              </div>
              <div id="upgrade_link" class="go_pro-container">
                <button class="stubs_btn stubs_btn_outline-primary darkmode">
                  <i class="ti ti-arrow-big-up-lines"></i> Go Pro
                </button>
              </div>
            </div>
        </div>
        <div class="bottom-content" id="dragbottom-content">
            <div class="resizer-horizontal" id="dragresizer-horizontal"></div>
            <div class="h-100">
              <div id="all_response_containers" class="stubs_scroll-cus">
              </div>   
            </div>
        </div>
      </div>
    </div>
</div>     
`;        
        console.log(fullFileData);
        //always do replace for the top level html scopes
        let controlStructure = await TREESIT.getHtmlElementScopeForLine(fullFileData, 47);
        console.log("html control structure");
        console.log(controlStructure);
};

testTreesitHtml();
*/


//testing some treee sitting 

//CHATGPT.estimateFileTokens("test");
//let file1 = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\js\\ui_image_handlers.js";
//let fileData1 = fs.readFileSync(file1, 'utf-8');  
//should make this promise instead
/*
TREESIT.getFileStub(file1, "", function(finalText, md5){
    console.log("again");
    console.log(finalText);      
});
*/


//test dependency graph stuff
/*
setTimeout(async function(){
    let searchLine = "$('body').on('click', '#upload_image', function(){";    
    let cStruct = await DGRAPH.getControlStructureForLine(file1, searchLine, fileData1);

    console.log("Seraching for " + searchLine);
    console.log(cStruct);
}, 5000);
*/


//console.log("Testing Codemirror Stuff");
//let mergefile1 = "C:\\wamp\\www\\scrapehawk\\scrapehawk-extension\\contentscript_hawk.js";
//let mergefile2 = "C:\\wamp\\www\\stubs\\stubs-ai-assistant\\stubble\\scrapehawkext\\contentscript_hawk.js";

/*
let mergefile1 = "C:\\wamp\\www\\snipcss\\extension\\js\\selectionBox.js";
let mergefile2 = "C:\\wamp\\www\\scrapehawk\\scrapehawk-extension\\js\\selectionBox.js";


let fileData1 = fs.readFileSync(mergefile1, 'utf-8');  
let fileData2 = fs.readFileSync(mergefile2, 'utf-8');  
//console.log("filedata1");
//console.log(fileData1);
//console.log("filedata2");
//console.log(fileData2);

let origFileObj = {};
let modFileObj = {};

origFileObj['contentscript_hawk.js'] = fileData1;
modFileObj['contentscript_hawk.js'] = fileData2;


DIFFR.loadNewDiffs(new Array(), origFileObj, modFileObj, ['stubs'], false, TABS.TAB_ARR[0]['uid']);
*/



//console.log("mysqlconfig");
//console.log(mysqlConfig);

//CHATGPT.testDatabaseLogger(mysqlConfig);
